/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>



#define VER         "0.1.1"
#define KEYPATH     "Software\\Van Dyke Technologies\\IMAP Notify\\Accounts\\%04d"
#define BUFFSZ      8192



int readreg(HKEY key, u_char *buff, u_char *value);
u_char *aftp_pwd(u_char *pwd);



int main(int argc, char *argv[]) {
    HKEY    key;
    u_char  keybuff[BUFFSZ],
            value[BUFFSZ];
    int     i;


    setbuf(stdout, NULL);

    fputs("\n"
        "Imap Notify passwords decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    for(i = 1; ; i++) {
        sprintf(keybuff, KEYPATH, i);

        if(RegOpenKeyEx(HKEY_CURRENT_USER, keybuff, 0, KEY_READ, &key)) break;

        if(readreg(key, value, "Name") < 0) break;
        printf("\nE-mail:     %s\n", value);

        if(readreg(key, value, "IMAP Server") < 0) break;
        printf("Server:     %s\n", value);

        if(readreg(key, value, "Username") < 0) break;
        printf("Username:   %s\n", value);

        if(readreg(key, value, "Password") < 0) break;
        printf("Password:   %s\n", aftp_pwd(value));

        RegCloseKey(key);
    }

    if(i == 1) {
        fputs("\nNo registry keys found\n", stdout);
    }

    fputs("\n\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



int readreg(HKEY key, u_char *buff, u_char *value) {
    int valuelen = BUFFSZ;

    if(RegQueryValueEx(
        key,
        value,
        NULL,
        NULL,
        buff,
        (void *)&valuelen)) return(-1);
    return(0);
}


    // the algorithm is the same of Absolute FTP
u_char *aftp_pwd(u_char *pwd) {
    u_char  *ret;
    int     i,
            y,
            len;

    len = strlen(pwd) >> 1;
    ret = pwd;
    for(i = 0; i < len; i++) {
        sscanf(pwd, "%02x", &y);
        ret[i] = y;
        pwd += 2;
    }

    for(i = 4, y = 0; i < len; i++, y++) {
        ret[i] ^= ret[y & 3];
    }
    ret[i] = 0;
    return(ret + 4);
}

